﻿//A
#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
using namespace std;
int n,m,u,v,w,cnt,fa[110];
struct Edge{
	int u,v,w;
	bool operator < (const Edge e) const{
		return w<e.w;
	}
}e[110];
int find_(int x){
	return x==fa[x]?x:fa[x]=find_(fa[x]);
}
void uni(int x,int y){
	fa[find_(x)]=find_(y);
}
int Kruskal(){
	int sum=0;
	sort(e,e+cnt);
	for(int i=0;i<=n;i++) fa[i]=i;
	for(int i=0;i<cnt;i++){
		if(find_(e[i].u)!=find_(e[i].v)){
			uni(e[i].u,e[i].v);
			sum+=e[i].w;
			//每次加上新加入的边的长度
		}
	}
	return sum;
}
int main(){
	char c;
	while(~scanf("%d",&n)&&n){
		cnt=0;
		//cnt表示边的数目
		for(int i=1;i<n;i++){
			cin>>c;
			u=c-'A';//将字符表示为数字，比如说A表示为0，B表示为1……Z表示为25
			scanf("%d",&m);
			while(m--){
				cin>>c;
				v=c-'A';//同理
				scanf("%d",&w);
				e[cnt].u=u,e[cnt].v=v,e[cnt].w=w;
				cnt++;
			}
		}
		printf("%d\n",Kruskal());
	}
	return 0;
}

//B
#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
using namespace std;
int n,m,u,v,cnt,fa[110];
int g[110][110];
struct Edge{
	int u,v,w;
	bool operator < (const Edge e) const{
		return w<e.w;
	}
}e[5100];
int find_(int x){
	return x==fa[x]?x:fa[x]=find_(fa[x]);
}
void uni(int x,int y){
	fa[find_(x)]=find_(y);
}
int Kruskal(){
	int sum=0;
	sort(e,e+cnt);
	for(int i=0;i<=n;i++) fa[i]=i;
	for(int i=0;i<cnt;i++){
		if(find_(e[i].u)!=find_(e[i].v)){
			uni(e[i].u,e[i].v);
			sum+=e[i].w;
		}
	}
	return sum;
}
int main(){
	while(~scanf("%d",&n)){
		cnt=0;
		for(int i=1;i<=n;i++)
			for(int j=1;j<=n;j++)
				scanf("%d",&g[i][j]);
		scanf("%d",&m);
		for(int i=0;i<m;i++){
			scanf("%d%d",&u,&v);
			g[u][v]=g[v][u]=0;
			//将已有的边的长度标记为0，那么在进行Kruskal算法的时候，它们将被优先考虑，并且因为其长度被更改为0，所以将其加入的花销被忽略了。
		}
		for(int i=1;i<=n;i++){
			for(int j=i+1;j<=n;j++){
				e[cnt].u=i,e[cnt].v=j,e[cnt].w=g[i][j];
				cnt++;
			}
		}
		printf("%d\n",Kruskal());
	}
	return 0;
}

//C
//Dijkstra
#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
using namespace std;
const int N=1010;
int n,m,t,u,v,w,g[N][N],vis[N],d[N];
int Dijkstra(){
	memset(vis,0,sizeof(vis));
	for(int i=0;i<=n;i++) d[i]=-1;
	d[1]=0;
	for(int i=1;i<=n;i++){
		int u=-1;
		for(int j=1;j<=n;j++) if(!vis[j]){
			if(u==-1||d[u]<d[j]) u=j;
		}
		if(u==-1) break;
		vis[u]=1;
		for(int j=1;j<=n;j++) if(!vis[j]&&g[u][j]){
			if(u==1){
				d[j]=g[u][j];continue;
			}
			int tmp=min(d[u],g[u][j]);
			if(d[j]==-1) d[j]=d[u];
			else if(d[j]<tmp) d[j]=tmp;
		}
	}
	return d[n];
}
int main(){
	//freopen("in.txt","r",stdin);
	scanf("%d",&t);
	for(int tCase=1;tCase<=t;tCase++){
		scanf("%d%d",&n,&m);
		memset(g,0,sizeof(g));
		for(int i=0;i<m;i++){
			scanf("%d%d%d",&u,&v,&w);
			g[u][v]=g[v][u]=w;
		}
		printf("Scenario #%d:\n%d\n\n",tCase,Dijkstra());
	}
	return 0;
}

//Kruskal
#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
using namespace std;
const int mxn=1005;
int t,n,m,a,b,c,fa[mxn];
struct edge{
	int a,b,cost;
	bool operator < (const edge e) const{
		return cost>e.cost;
	}
}g[mxn*mxn];
int find(int u){
	return fa[u]==-1?u:fa[u]=find(fa[u]);
}
void uni(int x,int y){
	fa[find(x)]=find(y);
}
int main(){
	//freopen("in.txt","r",stdin);
	scanf("%d",&t);
	for(int C=1;C<=t;C++){
		memset(fa,-1,sizeof(fa));
		scanf("%d%d",&n,&m);
		for(int i=0;i<m;i++){
			scanf("%d%d%d",&g[i].a,&g[i].b,&g[i].cost);
		}
		sort(g,g+m);
		int ans;
		for(int i=0;i<m;i++) if(find(g[i].a)!=find(g[i].b)){
			uni(g[i].a,g[i].b);
			if(find(1)==find(n)){
				ans=g[i].cost;
				break;
			}
		}
		printf("Scenario #%d:\n%d\n\n",C,ans);
	}
	return 0;
}

//D
#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
using namespace std;
const int N=510,inf=21e8;
int n,m,u,v,w,d[N],vis[N],g[N][N];
//用结构体来保存边，方便遍历
struct Edge{
	int u,v;
}e[N*N/2];
void Dijkstra(){
	memset(vis,0,sizeof(vis));
	for(int i=0;i<=n;i++) d[i]=inf;
	d[1]=0;
	for(int i=1;i<=n;i++){
		int u=-1;
		for(int j=1;j<=n;j++) if(!vis[j]){
			if(u==-1||d[u]>d[j]) u=j;
		}
		if(u==-1) break;
		vis[u]=1;
		for(int j=1;j<=n;j++) if(!vis[j]&&g[u][j]){
			d[j]=min(d[j],d[u]+g[u][j]);
		}
	}
}
int main(){
	int tcase=1;
	while(~scanf("%d%d",&n,&m)&&(n||m)){
		memset(g,0,sizeof(g));
		for(int i=0;i<m;i++){
			scanf("%d%d%d",&u,&v,&w);
			if(u>v) swap(u,v);
			//使得，如果是第二种情况的话，点的编号是从小到大
			g[u][v]=g[v][u]=w;
			e[i].u=u,e[i].v=v;
		}
		Dijkstra();
		int mx1=0,p1=1,p2,p3;
		double mx2=0;
		//mx1保存d[i]中的最大值，即题解中的第一种情况
		//mx2记录第二种情况的最大值
		//p1表示第一种情况下最后一块倒下的骨牌的编号
		//p2和p3表示第二种情况的骨牌的编号
		for(int i=1;i<=n;i++) if(d[i]>mx1){
			mx1=d[i],p1=i;
		}
		for(int i=0;i<m;i++){
			double tmp=(d[e[i].u]+d[e[i].v]+g[e[i].u][e[i].v])/2.0;
			//注意这里用2.0
			if(tmp>mx2) p2=e[i].u,p3=e[i].v,mx2=tmp;
		}
		printf("System #%d\n",tcase++);
		if(mx1>=mx2) printf("The last domino falls after %.1f seconds, at key domino %d.\n\n",(float)mx1,p1);
		else printf("The last domino falls after %.1f seconds, between key dominoes %d and %d.\n\n",mx2,p2,p3);
	}
	return 0;
}

//E
#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
using namespace std;
int n,m,p,cost,d[105][105],inf=1<<29;
void Floyd(){
	for(int k=1;k<=n;k++)
		for(int i=1;i<=n;i++)
			for(int j=1;j<=n;j++)
				d[i][j]=min(d[i][j],d[i][k]+d[k][j]);
}
int main(){
	//freopen("in.txt","r",stdin);
	while(~scanf("%d",&n)&&n){
		memset(d,0,sizeof(d));
		for(int i=1;i<=n;i++)
			for(int j=1;j<=n;j++)
				d[i][j]=inf;
		for(int i=1;i<=n;i++){
			scanf("%d",&m);
			for(int j=0;j<m;j++){
				scanf("%d%d",&p,&cost);
				d[i][p]=cost;
			}
		}
		Floyd();
		int tmp,ans=inf;
		for(int i=1;i<=n;i++){
			tmp=0;
			//枚举所有源点的情况
			for(int j=1;j<=n;j++){
				if(i==j) continue;
				tmp=max(tmp,d[i][j]);
			}
			//找出以当前点为源点，将消息传遍整个“网”的最大花销
			if(ans>tmp)
				ans=tmp,p=i;
		}
		if(ans==inf){
			//即无论以哪个店为源点，都有人收不到消息
			puts("disjoint");
		}
		else printf("%d %d\n",p,ans);
	}
	return 0;
}

//F
#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
using namespace std;
const int N=110,inf=21e8;
int m,n,c,s,num,L,R,t1,t2;
int g[N][N],d[N],vis[N],level[N];
int Dijkstra(){
	int ans=inf;
	for(int l=level[1]-m,r;l!=level[1]+1;l++){
	    d[0]=0,r=l+m;
		//枚举等级区间
		memset(vis,0,sizeof(vis));
		for(int i=1;i<=n;i++) d[i]=inf;
	    for(int i=0;i<=n;i++){
		    int u=-1;
			for(int j=1;j<=n;j++){
				//不在枚举的等级区间内的点，不进行访问
				if(level[j]<l||level[j]>r) vis[j]=1;
			}
		    for(int j=0;j<=n;j++) if(!vis[j]){
				if(u==-1||d[u]>d[j]) u=j;
		    }
			if(u==-1) break;
		    vis[u]=1;
		    for(int j=0;j<=n;j++) if(!vis[j]&&g[u][j]){
				d[j]=min(d[j],d[u]+g[u][j]);
		    }
	    }
		if(d[1]<ans) ans=d[1];
	}
	return ans;
}
int main(){
	while(~scanf("%d%d",&m,&n)){
		memset(g,0,sizeof(g));
		memset(level,0,sizeof(level));
		scanf("%d%d%d",&c,&s,&num);
		g[0][1]=c;
		level[1]=s;
		L=s-m,R=s+m;//L和R表示在将要枚举的等级范围的极大和极小值
		for(int i=0;i<num;i++){
			scanf("%d%d",&t1,&t2);
			g[t1][1]=t2;
		}
		for(int i=2;i<=n;i++){
			scanf("%d%d%d",&c,&s,&num);
			//在将要枚举的范围内的点才有存入图中的必要
			if(s>=L&&s<=R){
		        g[0][i]=c;
				level[i]=s;
				for(int j=0;j<num;j++){
					scanf("%d%d",&t1,&t2);
					g[t1][i]=t2;
				}
			}
			else for(int j=0;j<num;j++)
				scanf("%d%d",&t1,&t2);
		}
		printf("%d\n",Dijkstra());
	}
	return 0;
}

//G
#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
#include<cmath>
#include<queue>
#define sqr(x) (x)*(x)
#define eps 1e-8
using namespace std;
const int inf=21e8;
const int N=21,M=8010;
const double pi=acos(-1.0);
int n,head[N*N],nxt[M],to[M],vis[N*N],cnt;
double x[N],y[N],cost[M],d[N*N],R,ans;
void addedge(int u,int v,double w){
	cost[cnt]=w;
	to[cnt]=v;
	nxt[cnt]=head[u];
	head[u]=cnt++;
}
bool online(int l,int m,int r){
	double t1=(y[r]-y[m])*(x[m]-x[l]);
	double t2=(y[m]-y[l])*(x[r]-x[m]);
	return fabs(t1-t2)<eps;
}
double cal_ang(int pre,int u,int to){
	if(!online(pre,u,to)){
		double tx1=x[u]-x[pre],ty1=y[u]-y[pre];
		double tx2=x[to]-x[u],ty2=y[to]-y[u];
		double ang=fabs(atan2(ty1,tx1)-atan2(ty2,tx2));
		ang=ang/pi*180;
		if(ang>180) ang=360.0-ang;
		return ang;
	}
	return 0;
}
void dijkstra(){
	memset(vis,0,sizeof(vis));
	int tot=n*n;
	for(int i=0;i<tot;i++) d[i]=inf;
	d[0]=0;
	for(int i=0;i<tot;i++){
		int u=-1;
		for(int j=0;j<tot;j++) if(!vis[j]){
			if(u==-1||d[u]>d[j]) u=j;
		}
		if(u==-1) break;
		vis[u]=1;
		for(int j=head[u];~j;j=nxt[j]) if(!vis[to[j]]){
			d[to[j]]=min(d[to[j]],d[u]+cost[j]);
		}
	}
}
int main(){
	//freopen("in.txt","r",stdin);
	while(~scanf("%lf%d",&R,&n)&&(R!=-1&&~n)){
		cnt=0;
		memset(head,-1,sizeof(head));
		for(int i=0;i<n;i++)
			scanf("%lf%lf",&x[i],&y[i]);
		x[n]=2*x[0]-x[n-1],y[n]=2*y[0]-y[n-1];
		for(int i=1;i<n;i++){
			double tmp=sqr(x[0]-x[i])+sqr(y[0]-y[i]);
			if(tmp<=R*R){
				tmp=sqrt(tmp)+cal_ang(n,0,i);
				addedge(0,i,tmp);
			}
		}
		for(int i=0;i<n;i++){
			for(int j=1;j<n;j++)
				for(int k=1;k<n;k++){
					if(i==j||i==k||j==k) continue;
					double tmp=sqr(x[i]-x[j])+sqr(y[i]-y[j]);
					if(tmp<=R*R){
						tmp=sqr(x[j]-x[k])+sqr(y[j]-y[k]);
						if(tmp<=R*R){
							tmp=sqrt(tmp)+cal_ang(i,j,k);
							addedge(i*n+j,j*n+k,tmp);
						}
					}
				}
		}
		dijkstra();
		double ans=d[n-1];
		for(int i=2;i<n;i++) ans=min(ans,d[n*i-1]);
		if(ans==inf) puts("impossible");
		else printf("%d\n",(int)(ans+0.5));
	}
	return 0;
}